package org.gcube.portlets.user.geoportaldataviewer.client.ui;

import org.gcube.portlets.user.geoportaldataviewer.client.ui.products.concessioni.ConcessioneView;
import org.gcube.portlets.user.geoportaldataviewer.shared.GeoNaItemRef;
import org.gcube.portlets.user.geoportaldataviewer.shared.products.ConcessioneDV;

import com.github.gwtbootstrap.client.ui.Button;
import com.github.gwtbootstrap.client.ui.constants.ButtonType;
import com.github.gwtbootstrap.client.ui.constants.IconType;
import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.HTMLPanel;
import com.google.gwt.user.client.ui.Widget;

public class DetailsPanel extends Composite {

	private static DetailsPanelUiBinder uiBinder = GWT.create(DetailsPanelUiBinder.class);
	
	@UiField
	Button closeButton;
	
	@UiField
	HTMLPanel datailsContainerPanel;
	
	@UiField
	HTMLPanel detailsHTMLPanel;

	interface DetailsPanelUiBinder extends UiBinder<Widget, DetailsPanel> {
	}

	
	public DetailsPanel() {
		initWidget(uiBinder.createAndBindUi(this));
		closeButton.setType(ButtonType.LINK);
		closeButton.setIcon(IconType.REMOVE_SIGN);
		
		closeButton.addClickHandler(new ClickHandler() {
			
			@Override
			public void onClick(ClickEvent event) {
				showPanelDetails(false);
			}
		});
		
	}

	
	public void showDetailsFor(ConcessioneDV cdv, GeoNaItemRef geonaItemRef) {
		datailsContainerPanel.clear();
		if(detailsHTMLPanel.getParent()!=null)
			detailsHTMLPanel.getParent().getElement().setScrollTop(0);
		
		datailsContainerPanel.add(new ConcessioneView(geonaItemRef, cdv));
		showPanelDetails(true);
	}
	
	private void showPanelDetails(boolean visible) {
		detailsHTMLPanel.setVisible(visible);
	}

}
